#include "StrPairList.H"
#include <map>

class StrPairListMap:public map<string,string> {
};

StrPairList::StrPairList() {
	pthread_mutex_init(&_lock,NULL);
	_list=new StrPairListMap;
}

StrPairList::StrPairList(const StrPairList &spl) {
	_list=new StrPairListMap;
	(*_list)=*(spl._list); 
	pthread_mutex_init(&_lock,NULL);
}

StrPairList::~StrPairList() {
	pthread_mutex_destroy(&_lock);
}

StrPairList &StrPairList::operator=(const StrPairList &spl) {
	tlock();
	(*_list)=*(spl._list); 
	tunlock();
	return (*this);
}

int StrPairList::add(const string &key, const string &data) {
	tlock();
	(*_list)[key]=data;
	tunlock();
	return 0;
}

int StrPairList::remove(const string &key) {
	tlock();
	(*_list).erase(key);
	tunlock();
	return 0;
}

bool StrPairList::inlist(const string &key) const {
	bool gotit;
	tlock();
	gotit=((*_list).find(key) != (*_list).end());
	tunlock();
	return (gotit);
}

int StrPairList::get(const string &key, string &data) const {
	tlock();
	map<string,string>::const_iterator cur;
	if ((cur=(*_list).find(key)) != (*_list).end()) {
		data=(*cur).second;
		tunlock();
		return 0;
	}
	tunlock();
	return -1;
}

int StrPairList::get(unsigned int idx, string &key, string &data) const {
	map<string,string>::const_iterator cur;
	unsigned int i;

	tlock();
	for(i=0,cur=(*_list).begin();cur!=(*_list).end();cur++,i++) {
		if (i==idx) {
			key=(*cur).first;
			data=(*cur).second;
			tunlock();
			return 0;
		}
	}
	tunlock();
	return -1;
}

string StrPairList::operator[](unsigned int idx) const {
	map<string,string>::const_iterator cur;
	unsigned int i;
	string tmp;

	tlock();
	for(i=0,cur=(*_list).begin();cur!=(*_list).end();cur++,i++) {
		if (i==idx) {
			tunlock();
			return ((*cur).second);
		}
	}
	tunlock();
	return tmp;
}

unsigned int StrPairList::size() const {
	return (*_list).size();
}

void StrPairList::clear() {
	(*_list).clear();
}
